\def\N{\mathbb{N}}
\def\R{\mathbb{R}}
% new theorems

\newtheorem{remark}[theorem]{Remark}


% some definitions to make typing easier.

\newcommand{\dsp}{\displaystyle}
\def \R{\mathbb{R}}
\def\GRAD{\mathop{\rm \nabla}\nolimits}
\def\DIV{\mathop{\rm div}\nolimits}
\def\GrandO{\mathop{\mathcal{ O}}\nolimits}
%\newcommand{\ENS}[2]{\left\{ {{#1},\hdots,{#2}}\right\}}
\newcommand{\ENS}[2]{\ldbrack {{#1},{#2}}\rdbrack}
\newcommand{\ENSoc}[2]{\rdbrack {{#1},{#2}}\rdbrack} % ]a,b]  open/close
\newcommand{\ENSco}[2]{\ldbrack {{#1},{#2}}\ldbrack} % [a,b[
\newcommand{\ENSoo}[2]{\rdbrack {{#1},{#2}}\ldbrack}  % ]a,b[


\def\SpaceFunc{\rm V}
\def\Span{\mathop{\rm Span}\nolimits}
\newcommand{\SetFont}[1]{\mathcal{#1}}


\newcommand{\vecb}[1]{\pmb{#1}}
\newcommand{\VEC}[1]{\vecb{#1}}                   % Vector
\newcommand{\MAT}[1]{\mathbb{#1}}
\newcommand{\MATT}[1]{\mathbb{#1}^{\text{\texttt{t}}}} % Transpose of a matrix
\def\MatSet{\mathcal{M}}                          % Matrix Set
\newcommand{\MS}[2]{\MatSet_{#1}(#2)} 
\newcommand{\DOT}[2]{%
\left\langle #1,#2 \right\rangle}
\newcommand{\DOTT}[2]{%
\left\langle #1,#2 \right\rangle_3}

\newcommand{\DP}[2]{\frac{\partial #1}{\partial #2}}
\newcommand{\DPM}[3]{\frac{\partial^{#3} #1}{\partial #2^{#3}}}
% Derivee partielle
\newcommand{\DD}[2]{\frac{d #1}{d #2}}
\newcommand{\DPS}[2]{\frac{\partial^2 {#1}}{\partial {#2}^2}}
\newcommand{\DPSC}[3]{\frac{\partial^2 {#1}}{\partial {#2}\partial {#3}}}
\newcommand{\DPn}[3]{\frac{\partial^{#3} #1}{\partial #2^{#3}}}
\newcommand{\DDn}[3]{\frac{d^{#3} #1}{d #2^{#3}}}

% for FEM
\newcommand\Local[1]{\tilde{#1}}                  % Local to a triangle (numerotation, ...)

\newcommand\TT[1]{{\widehat{#1}}}

\def\DOM{\Omega}
\def\DOMT{\TT{\Omega}} % \DOM\times[0,T]
\def\Th{{\cal T}_h}
\newcommand{\xt}[1]{ {\TT{\vecb{#1}}} }
\def\DOMH{{\Omega_h}}
\def\BD{\Gamma}
\def\BDH{\Gamma_h}
\newcommand\BDHC[1]{\Gamma_{h,#1}}
\def\BDMesh{\mathcal{B}_h}

\def\genMesh{\mathcal{M}_h} % generic Mesh (domain or boundary mesh)

\def\BDT{\TT{\Gamma}}
\def\nq{{\mathop{\rm n_q}\nolimits}}
\def\nqs{{\mathop{\rm n^2_q}\nolimits}}
\def\nme{{\mathop{\rm n_{me}}\nolimits}}
\def\nbe{{\mathop{\rm n_{be}}\nolimits}}
\def\dd{{\rm d}}
\def\q{{\rm q}}                                   % Nodes
\def\qL{\Local{\q}}                               % Local nodes
\def\me{\mathop{\rm me}\nolimits}                 % Mesh Elements
\def\be{\mathop{\rm be}\nolimits}                 % Boundary Elements
\def\bel{\mathop{\rm bel}\nolimits}                 % Boundary Elements label
%\def\Taires{\mathop{\rm areas}\nolimits}
\def\Taires{\mathop{\rm vol}\nolimits}
\def\areas{{\Taires}}
\def\ndf{{\mathop{\rm n_{dof}}\nolimits}}
\def\ndfe{{\mathop{\rm n_{dfe}}\nolimits}}
\def\ndfes{{\mathop{\rm n^2_{dfe}}\nolimits}}
\def\ndfs{{\mathop{\rm n^2_{df}}\nolimits}}
\def\ndof{{\mathop{\rm n_{dof}}\nolimits}}

\def\labels{\mathop{\rm lab}\nolimits}
\def\nlabels{\mathop{\rm n_{lab}}\nolimits}
\newcommand{\Ilabels}[1]{ \SetFont{I}_{\labels}^{#1}}

\def\BasisFuncBa{\vecb{\psi}}    
\def\BasisFuncBb{\vecb{\psi}}
\def\area{{\rm area}}
\def\volume{{\rm vol}}
\def\volumes{{\rm vols}}
\newcommand{\modulo}[2]{ {#1}\mod{#2} }

\def\al{\mathop{\rm \nu}\nolimits}
\def\il{{\rm \alpha}}
\def\jl{{\rm \beta}}

\def\Mass{\mathbb{M}}
\def\MasseElem{\Masse^e}
\newcommand{\MasseF}[1]{\Masse^{[{#1}]}}
\newcommand{\MasseFElem}[1]{\Masse^{e,[{#1}]}}
\newcommand{\MassWElem}[1]{\MasseFElem{#1}}
\def\Stiff{\mathbb{S}}
\def\StiffElem{\mathbb{S}^e}
\def\StiffThreed{\mathbb{Q}}

\newcommand{\Ph}[1]{{#1}_h}
% Scalar Fields
\def\Loperator{\mathcal{L}}
\newcommand\Loperatorfunc[1]{\Loperator_{#1}}
\def\LVecoperator{\mathbb{\mathcal{H}}}
\newcommand\Hoperatorfunc[1]{\Hoperator_{#1}}
\def\Doperator{\mathcal{D}}
\newcommand\Doperatorfunc[1]{\mathcal{D}_{#1}}
\def\Dhoperator{\Ph{\Doperator}}
\def\MatD{\MAT{D}}
\def\MatDelem{\MAT{D}^e}



\def\FuncInt{\mathcal{F}^h}
\def\FuncDataInt{\overline{\FuncInt}}

\def\FoncBase{\varphi}
\def\BasisFunc{\FoncBase}
\def\FoncBaseLocale{\Local{\FoncBase}}
\def\BasisFuncLocal{\Local{\FoncBase}}

%\newcommand{\BDBasisFunc}[2]{\BasisFunc^{[#1]}_{#2}} % Boundary basis function
\newcommand{\BDBasisFunc}[2]{\BDMesh(#1).\BasisFunc_{#2}}
%$\BDMesh(l).\BasisFunc_j,$


\def\FoncBaseDeuxDLocale{\ASymbol{\Local{\vecb{\psi}}}} % local 2D basis function 
% Vector Fields
\def\Hoperator{\mathcal{H}}
\def\Hhoperator{\Ph{\mathcal{H}}}
\def\MatH{\MAT{H}}
\def\MatHelem{\MAT{H}^e}

\def\vecBasisAFunc{\ASymbol{{\vecb{\psi}}}} % alternate basis function
\def\vecBasisBFunc{\ASymbol{{\vecb{\psi}}}} % block basis function
\def\vecBasisFunc{\ASymbol{{\vecb{\psi}}}}  % generic vector field basis function

\def\vecBasisAFuncLocal{\ASymbol{\Local{\vecb{\psi}}}}
\def\vecBasisBFuncLocal{\ASymbol{\Local{\vecb{\psi}}}}
\def\vecBasisFuncLocal{\ASymbol{\Local{\vecb{\psi}}}}

\def\FuncBasisAVecLocal{\ASymbol{\Local{\vecb{\psi}}}}
\def\FuncBasisBVecLocal{\ASymbol{\Local{\vecb{\psi}}}}

\def\vecBasisA{\mathcal{B}_a} % alternate basis in vector field
\def\vecBasisB{\mathcal{B}_b} % block basis in vector field

\def\vecBasisALocal{\Local{\mathcal{B}}_a} % local alternate basis in vector field
\def\vecBasisBLocal{\Local{\mathcal{B}}_b} % local block basis in vector field
\def\vecBasisLocal{\Local{\mathcal{B}}} % local block basis in vector field

\def\bijIndFuncBasisA{\mathcal{T}_a} %  alpha=d(i-1)+m = \mathcal{T}_a(i,m)
\def\bijIndFuncBasisB{\mathcal{T}_b} %  alpha=i+(m-1)\nq = \mathcal{T}_b(i,m)
\def\bijIndFuncBasis{\mathcal{T}}    % generic
\def\bijIndFuncBasisALocal{\Local{\mathcal{T}}_a} %  alpha=d(l-1)+m = \local{\mathcal{T}}_a(l,m)
\def\bijIndFuncBasisBLocal{\Local{\mathcal{T}}_b} %  alpha=l+(m-1)(d+1) = \Local{\mathcal{T}}_b(l,m)
\def\bijIndFuncBasisLocal{\Local{\mathcal{T}}}

\def\HUn{{\rm H}^1}
\newcommand{\HUnD}[1]{{{\HUn}({#1})}}
\def\HUnH{{\rm H}^{1,h}}
\newcommand{\HUnHD}[1]{{{\HUnH}({#1})}}
\def\HUnZero{{\rm H}^1_0}
\newcommand{\HUnZeroD}[1]{{\HUnZero}({#1})}
\newcommand{\HUngD}[2]{{{\HUn_{#1}}({#2})}}
\newcommand{\HUngHD}[2]{{{\HUnH_{#1}}({#2})}}
\newcommand{\HS}[3]{ {{\rm H}^{#1}_{#2}({#3})}}
\newcommand{\WS}[2]{ W^{#1}({#2})}
\newcommand{\trace}[1]{ \mathop{\gamma_{#1}}\nolimits}

\newcommand{\VFM}[1]{\vecb{\mathcal{#1}}} % Vector Field function big

\newcommand{\LpD}[2]{ L^{#1}(#2)}
%\def\LDeux{L_2}
%\newcommand{\LDeuxD}[1]{{\LDeux}({#1})}
\newcommand{\LDeuxD}[1]{\LpD{2}{#1}}
\def\LUn{L^1} % Espace L_1
\newcommand{\LUnD}[1]{{\LUn}({#1})}
\def\LInf{L^\infty} % Espace L_\infty
\newcommand{\LInfD}[1]{{\LInf}({#1})}

\def\BasisFuncTwoD{\vecb{\psi}}                         % for elasticity
\def\BasisFuncTwoDL{\Local{\BasisFuncTwoD}}
\newcommand{\ASymbol}[1]{#1}                            % alternate numbering symbol
\def\StiffElas{\ASymbol{\mathbb{K}}}
\def\StiffElasElem{{\ASymbol{\mathbb{K}}}^e}
\def\Odc{\epsilon}
\def\Od{\vecb{\Odc}}                                    % strain tensor
\def\Odv{\underline{\Od}}                              
\def\Ocv{\mathop{\rm \vecb{\underline{\Occ}}}\nolimits}
\def\Occ{\sigma}

\def\Num{{\mathop{\rm Num}\nolimits}}
\newcommand{\bO}[1]{\mathcal{O}\left({#1}\right)}   

\newcommand{\foncdefsmall}[3]{%
{#1}  : {#2} \longrightarrow  {#3} 
}

\newcommand{\FONC}[5]{
\left\{ \begin{array}{lclcl}
#1 & : & #2 & \longrightarrow & #3 \\
& & #4 &  \longmapsto & #5
\end{array}\right.
}

\newcommand{\foncdef}[5]{%
\begin{array}{lclcl}
#1 & :& #2 &\longrightarrow & #3 \\
      & & #4 &\longmapsto & #5
\end{array}
}

\newcommand{\seminorm}[1]{
\left| {#1} \right|
}

\newcommand{\norm}[1]{
\left\| {#1} \right\|
}
